import { EventEmitter, ElementRef, AfterViewInit, OnDestroy, ChangeDetectorRef, OnChanges, SimpleChanges } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { EditorConfig, ThemeType } from '../../interfaces/editor-config.interface';
import { SyntaxHighlightService } from '../../services/syntax-highlight.service';
import { EditorConfigService } from '../../services/editor-config.service';
import * as i0 from "@angular/core";
export declare class HtmlEditorComponent implements ControlValueAccessor, AfterViewInit, OnDestroy, OnChanges {
    private syntaxHighlightService;
    private editorConfigService;
    private cdr;
    config: EditorConfig;
    theme: ThemeType;
    readonly: boolean;
    placeholder: string;
    contentChange: EventEmitter<string>;
    focus: EventEmitter<void>;
    blur: EventEmitter<void>;
    editorTextarea: ElementRef<HTMLTextAreaElement>;
    value: string;
    highlightedContent: string;
    lineNumbers: number[];
    private onChange;
    private onTouched;
    private isDisabled;
    constructor(syntaxHighlightService: SyntaxHighlightService, editorConfigService: EditorConfigService, cdr: ChangeDetectorRef);
    ngOnChanges(changes: SimpleChanges): void;
    ngAfterViewInit(): void;
    ngOnDestroy(): void;
    writeValue(value: any): void;
    registerOnChange(fn: any): void;
    registerOnTouched(fn: any): void;
    setDisabledState(isDisabled: boolean): void;
    handleInput(event: Event): void;
    handleKeydown(event: KeyboardEvent): void;
    handleFocus(): void;
    handleBlur(): void;
    handleScroll(event: Event): void;
    private updateHighlighting;
    private updateLineNumbers;
    private insertTab;
    private handleAutoIndentation;
    private handleClosingTagIndentation;
    private findMatchingOpeningTagIndent;
    private updateValue;
    trackByLineNumber(index: number, lineNumber: number): number;
    static ɵfac: i0.ɵɵFactoryDeclaration<HtmlEditorComponent, never>;
    static ɵcmp: i0.ɵɵComponentDeclaration<HtmlEditorComponent, "witspry-html-editor", never, { "config": { "alias": "config"; "required": false; }; "theme": { "alias": "theme"; "required": false; }; "readonly": { "alias": "readonly"; "required": false; }; "placeholder": { "alias": "placeholder"; "required": false; }; }, { "contentChange": "contentChange"; "focus": "focus"; "blur": "blur"; }, never, never, true, never>;
}
